unsigned short *ramw;

unsigned long bcount,bcmd;
unsigned long a1step,a2step;
unsigned long a1flags,a2flags;
unsigned long a1pixel,a2pixel;
unsigned long a1base,a2base;
unsigned long a1clip;
unsigned long a1fpixel;
unsigned long a1fstep;
unsigned long a1inc;
unsigned long a1finc;
unsigned long pat0,pat1;

inline unsigned short blitr(unsigned long addr)
{
        if (addr<0x200000) return ramw[addr>>1];
        printf("Bad blit read %06X\n",addr);
        exit(-1);
}

inline unsigned short blitrb(unsigned long addr)
{
        if (addr<0x200000) { if (addr&1) return ramw[addr>>1]>>8; else return ramw[addr>>1]; }
        printf("Bad blit read %06X\n",addr);
        exit(-1);
}

inline void blitw(unsigned long addr, unsigned short val)
{
        if (addr<0x200000) { ramw[addr>>1]=val; return; }
        if ((addr>=0xF00400) && (addr<0xF00800)) { writeclut(addr,val); return; }
        printf("Bad blit write %06X %04X\n",addr,val);
        exit(-1);
}

inline void blitwb(unsigned long addr, unsigned short val)
{
        if (addr<0x200000)
        {
                if (addr&1) ramw[addr>>1]=(ramw[addr>>1]&0xFF)|(val<<8);
                else        ramw[addr>>1]=(ramw[addr>>1]&0xFF00)|val;
                return;
        }
        printf("Bad blit write %06X %04X\n",addr,val);
        exit(-1);
}

void doblit()
{
        int a1w,a2w;
        int x,pixelcount,linecount;
        int r,g,b,r2,g2,b2;
        unsigned long templ,src,dst,srcflags,dstflags;
        unsigned short tempw;
        unsigned char temp;
        int xpix1,ypix1,xpix2,ypix2,stx;
        unsigned long a1off,a2off;
        printf("%i %i %08X %08X\n",(a1flags>>13)&3,(a1flags>>9)&15,a1pixel,a2pixel);
        a1w=((a1flags>>13)&3)*(1<<(((a1flags>>9)&15)+1));
        a2w=((a2flags>>13)&3)*(1<<(((a2flags>>9)&15)+1));
        pixelcount=bcount&0xFFFF;
        linecount=bcount>>16;
        switch ((a1flags>>3)&7)
        {
                case 3: a1off=(a1pixel&0xFFFF);      break;
                case 4: a1off=((a1pixel&0xFFFF)<<1); break;
        }
        printf("%04X ",a1off);
        switch ((a2flags>>3)&7)
        {
                case 3: a2off=(a2pixel&0xFFFF);      break;
                case 4: a2off=((a2pixel&0xFFFF)<<1); break;
        }
        a1off+=((a1pixel>>16)*a1w);
        a2off+=((a2pixel>>16)*a2w);
        printf("Blit A1 %06X+%06X A2 %06X+%06X\n",a1base,a1off,a2base,a2off);
//#if 0
        while (1)
        {
                for (x=0;x<pixelcount;x++)
                {
                        if (bcmd&0x800)
                        {
                                src=a1base+a1off;
                                srcflags=a1flags;
                        }
                        else
                        {
                                src=a2base+a2off;
                                srcflags=a2flags;
                        }
                        if (bcmd&0x800)
                        {
                                dst=a2base+a2off;
                                dstflags=a2flags;
                        }
                        else
                        {
                                dst=a1base+a1off;
                                dstflags=a1flags;
                        }
                        switch ((bcmd>>21)&15)
                        {
                                case 0:
                                switch ((dstflags>>3)&7)
                                {
                                        case 3: /*8-bit*/
//                                        if (a1base==0x70800) printf("%06X %06X %i %i\n",(dst+x)>>1,dst,x,linecount);
                                        blitw(dst+x,0);
                                        break;
                                        default: printf("Bad 0 %i\n",(dstflags>>3)&7); exit(0);
                                }
                                break;
                                case 12:
                                switch ((srcflags>>3)&7)
                                {
                                        case 3: /*8-bit*/
                                        temp=blitrb(src+x);
                                        break;
                                        case 4: /*16-bit*/
                                        tempw=blitr(src+(x<<1));
                                        break;
                                        default: printf("Bad src 12 %i\n",(dstflags>>3)&7); exit(0);
                                }
                                switch ((dstflags>>3)&7)
                                {
                                        case 3: /*8-bit*/
                                        blitwb(dst+x,temp);
                                        break;
                                        case 4: /*16-bit*/
                                        blitw(dst+(x<<1),tempw);
                                        break;
                                        default: printf("Bad dst 12 %i\n",(dstflags>>3)&7); exit(0);
                                }
                                break;
                                default: printf("Bad BCMD %i\n",(bcmd>>21)&15); exit(0);
                        }
                }
                a1base+=a1w;
                a2base+=a2w;
                linecount--;
//                printf("%i %06X\n",linecount,a1base);
                if (!linecount) return;
        }
//        #endif
        printf("Starting that goddamn blitter\n");
        printf("A1=%06X A2=%06X\n",a1base,a2base);
        printf("BCOUNT=%08X\n",bcount);
        printf("OP=%i B_CMD %08X\n",(bcmd>>21)&15,bcmd);
        printf("A1FLAGS=%08X A2FLAGS=%08X\n",a1flags,a2flags);
        printf("A1W=%i A2W=%i\n",a1w,a2w);
        exit(-1);
}

unsigned short readblitter(unsigned addr)
{
        switch (addr)
        {
                case 0xF02238: /*B_STATUS high*/
                return 0;
                case 0xF0223A: /*B_STATUS low*/
                return 1;

                default:
                printf("Bad blitter read %08X\n",addr);
                exit(-1);
        }
}

void writeblitter(unsigned addr, unsigned val)
{
        switch (addr)
        {
                case 0xF02200: /*A1_BASE high*/
                a1base=(a1base&0xFFFF)|(val<<16);
                break;
                case 0xF02202: /*A1_BASE low*/
                a1base=(a1base&0xFFFF0000)|val;
                break;

                case 0xF02204: /*A1_FLAGS high*/
                a1flags=(a1flags&0xFFFF)|(val<<16);
                break;
                case 0xF02206: /*A1_FLAGS low*/
                a1flags=(a1flags&0xFFFF0000)|val;
                break;

                case 0xF02208: /*A1_CLIP high*/
                a1clip=(a1clip&0xFFFF)|(val<<16);
                break;
                case 0xF0220A: /*A1_CLIP low*/
                a1clip=(a1clip&0xFFFF0000)|val;
                break;

                case 0xF0220C: /*A1_PIXEL high*/
                a1pixel=(a1pixel&0xFFFF)|(val<<16);
                break;
                case 0xF0220E: /*A1_PIXEL low*/
                a1pixel=(a1pixel&0xFFFF0000)|val;
                break;

                case 0xF02210: /*A1_STEP high*/
                a1step=(a1step&0xFFFF)|(val<<16);
                break;
                case 0xF02212: /*A1_STEP low*/
                a1step=(a1step&0xFFFF0000)|val;
                break;

                case 0xF02214: /*A1_FSTEP high*/
                a1fstep=(a1fstep&0xFFFF)|(val<<16);
                break;
                case 0xF02216: /*A1_FSTEP low*/
                a1fstep=(a1fstep&0xFFFF0000)|val;
                break;

                case 0xF02218: /*A1_FPIXEL high*/
                a1fpixel=(a1fpixel&0xFFFF)|(val<<16);
                break;
                case 0xF0221A: /*A1_FPIXEL low*/
                a1fpixel=(a1fpixel&0xFFFF0000)|val;
                break;

                case 0xF0221C: /*A1_INC high*/
                a1inc=(a1inc&0xFFFF)|(val<<16);
                break;
                case 0xF0221E: /*A1_INC low*/
                a1inc=(a1inc&0xFFFF0000)|val;
                break;

                case 0xF02220: /*A1_FINC high*/
                a1finc=(a1finc&0xFFFF)|(val<<16);
                break;
                case 0xF02222: /*A1_FINC low*/
                a1finc=(a1finc&0xFFFF0000)|val;
                break;

                case 0xF02224: /*A2_BASE high*/
                a2base=(a2base&0xFFFF)|(val<<16);
                break;
                case 0xF02226: /*A2_BASE low*/
                a2base=(a2base&0xFFFF0000)|val;
                break;

                case 0xF02228: /*A2_FLAGS high*/
                a2flags=(a2flags&0xFFFF)|(val<<16);
                break;
                case 0xF0222A: /*A2_FLAGS low*/
                a2flags=(a2flags&0xFFFF0000)|val;
                break;

                case 0xF02230: /*A2_PIXEL high*/
                a2pixel=(a2pixel&0xFFFF)|(val<<16);
                break;
                case 0xF02232: /*A2_PIXEL low*/
                a2pixel=(a2pixel&0xFFFF0000)|val;
                break;

                case 0xF02234: /*A2_STEP high*/
                a2step=(a2step&0xFFFF)|(val<<16);
                break;
                case 0xF02236: /*A2_STEP low*/
                a2step=(a2step&0xFFFF0000)|val;
                break;

                case 0xF02238: /*B_CMD high*/
                bcmd=(bcmd&0xFFFF)|(val<<16);
                break;
                case 0xF0223A: /*B_CMD low*/
                bcmd=(bcmd&0xFFFF0000)|val;
                doblit();
                break;

                case 0xF0223C: /*B_COUNT high*/
                bcount=(bcount&0xFFFF)|(val<<16);
                break;
                case 0xF0223E: /*B_COUNT low*/
                bcount=(bcount&0xFFFF0000)|val;
                break;

                case 0xF02268: /*PAT0 high*/
                pat0=(pat0&0xFFFF)|(val<<16);
                break;
                case 0xF0226A: /*PAT0 low*/
                pat0=(pat0&0xFFFF0000)|val;
                break;

                case 0xF0226C: /*PAT1 high*/
                pat1=(pat1&0xFFFF)|(val<<16);
                break;
                case 0xF0226E: /*PAT1 low*/
                pat1=(pat1&0xFFFF0000)|val;
                break;

                default:
                printf("Bad blitter write %08X %08X\n",addr,val);
                exit(-1);
        }
}
