#include <allegro.h>

int joy0col;

void writejerry(unsigned addr, unsigned val)
{
        switch (addr)
        {
                case 0xF10000: /*JPIT1*/
                case 0xF10002:
                return;

                case 0xF14000: /*JOYSTICK/CONFIG*/
                joy0col=val&15;
//                printf("Joy0col now %01X\n",val&15);
                break;

                case 0xF10014: /*CHRO_CLK*/
                break;

                case 0xF14800: /*EEPROM_WR*/
                break;

                case 0xF1A148: /*DAC/SSI*/
                case 0xF1A14A:
                case 0xF1A14C:
                case 0xF1A14E:
                case 0xF1A150:
                case 0xF1A152:
                case 0xF1A154:
                case 0xF1A156:
                break;

                default:
                printf("Bad Jerry write %08X %08X\n",addr,val);
                exit(-1);
        }
}

unsigned readjerry(unsigned addr)
{
        unsigned char temp=0xFF;
        switch (addr)
        {
                case 0xF14000: /*JOYSTICK*/
                if (!(joy0col&1))
                {
                        if (key[KEY_RIGHT]) temp&=~8;
                        if (key[KEY_LEFT]) temp&=~4;
                        if (key[KEY_DOWN]) temp&=~2;
                        if (key[KEY_UP]) temp&=~1;
                }
                if (!(joy0col&2))
                {
                        if (key[KEY_L]) temp&=~8;
                        if (key[KEY_7]) temp&=~4;
                        if (key[KEY_4]) temp&=~2;
                        if (key[KEY_1]) temp&=~1;
                }
                if (!(joy0col&4))
                {
                        if (key[KEY_2]) temp&=~8;
                        if (key[KEY_5]) temp&=~4;
                        if (key[KEY_8]) temp&=~2;
                        if (key[KEY_0]) temp&=~1;
                }
                if (!(joy0col&8))
                {
                        if (key[KEY_3]) temp&=~8;
                        if (key[KEY_6]) temp&=~4;
                        if (key[KEY_9]) temp&=~2;
                        if (key[KEY_K]) temp&=~1;
                }
//                printf("temp is %02X\n",temp);
                return temp<<8;
                case 0xF14002: /*JOYBUTS/CONFIG*/
                temp=3;
                if (!(joy0col&1) && key[KEY_A]) temp&=~2;
                if (!(joy0col&2) && key[KEY_S]) temp&=~2;
                if (!(joy0col&4) && key[KEY_D]) temp&=~2;
                if (!(joy0col&8) && key[KEY_F]) temp&=~2;
                if (!(joy0col&1) && key[KEY_Z]) temp&=~1;
                return temp;

                case 0xF14800:
                case 0xF15000: /*EEPROM_RD*/
                return 0xFFFF;
                default:
                printf("Bad Jerry read %08X\n",addr);
                exit(-1);
        }
}
