#include <allegro.h>

//#define pixel(y,x,c) ((short *)buffer->line[y])[x]=c
#define pixel(y,x,c) buffer->line[y][x]=c

BITMAP *buffer;
PALETTE pal;
RGB_MAP themap;
unsigned short *ramw;
unsigned long objaddr;
unsigned long clut[256];

void initvideo()
{
//        allegro_init();
//        set_color_depth(16);
        set_gfx_mode(GFX_AUTODETECT,400,300,0,0);
        buffer=create_bitmap(2048,1024);
        generate_332_palette(pal);
        pal[0].r=pal[0].g=pal[0].b=0;
        set_palette(pal);
        create_rgb_table(&themap, pal, NULL);
        rgb_map=&themap;
}

void writeobj(unsigned addr, unsigned val)
{
        switch (addr)
        {
                case 0xF00020: /*OBJ addr low*/
                objaddr&=0xFFFF0000;
                objaddr|=val;
                break;
                case 0xF00022: /*OBJ addr high*/
                objaddr&=0xFFFF;
                objaddr|=val<<16;
                printf("objaddr now %08X\n",objaddr);
                break;

                case 0xF00026: /*OBF addr low*/
                return;

                default:
                printf("Bad OBJ write %08X %04X\n",addr,val);
                exit(-1);
        }
}

void execobjlist(int line)
{
        unsigned long old=objaddr;
        unsigned long p1,p2,p3,p4,p6;
        unsigned long tempaddr,temp,temp2,origaddr;
        unsigned short tempw;
        int x,ins=0,xx,oldxx,xscale;
        if (!objaddr)
           return;
/*        if (!buffer)
        {
                buffer=create_bitmap(2048,1024);
                clear(buffer);
        }*/
        if (!line)
           clear(buffer);
//        printf("addr %06X %i\n",objaddr,line);
        line&=~1;
top:
//        printf("object ins %i\n",ins);
        origaddr=objaddr;
        p1=ramw[((objaddr&0x1FFFFF)>>1)+1]; p1|=ramw[(objaddr&0x1FFFFF)>>1]<<16; objaddr+=4;
        p2=ramw[((objaddr&0x1FFFFF)>>1)+1]; p2|=ramw[(objaddr&0x1FFFFF)>>1]<<16; objaddr+=4;
//        printf("%06X Obj %08X %08X\n",objaddr,p1,p2);
        switch (p2&7)
        {
                case 0: /*Bitmap*/
                p3=ramw[(objaddr>>1)+1]; p3|=ramw[objaddr>>1]<<16; objaddr+=4;
                p4=ramw[(objaddr>>1)+1]; p4|=ramw[objaddr>>1]<<16; objaddr+=4;
                tempaddr=((p2&0xFF000000)>>24)|(p1<<8);
                objaddr=(tempaddr<<3)&0x1FFFFF;
                temp2=(p4>>28)|((p3&0x3F)<<4);
                tempaddr=(p1>>11)<<3;
                temp=(p2>>3)&0x7FF;
                if ((temp|1)!=line) break;
                if (!((p2>>14)&0x3FF)) break;
                if (p3&0x8000)
                {
                        for (x=0;x<temp2<<3;x+=2)
                        {
                                tempw=ramw[(tempaddr&0x1FFFFF)>>1];
                                tempaddr+=2;
                                if (tempw>>8)   pixel(temp>>1,x+(p4&0xFFF),clut[tempw>>8]);
                                if (tempw&0xFF) pixel(temp>>1,x+(p4&0xFFF)+1,clut[tempw&0xFF]);
                        }
                }
                else
                {
                        for (x=0;x<temp2<<3;x+=2)
                        {
                                tempw=ramw[(tempaddr&0x1FFFFF)>>1];
                                tempaddr+=2;
                                pixel(temp>>1,x+(p4&0xFFF),clut[tempw>>8]);
                                pixel(temp>>1,x+(p4&0xFFF)+1,clut[tempw&0xFF]);
                        }
                }
                temp+=2;
                p2&=~0x3FF8;
                p2|=((temp&0x7FF)<<3);
                temp=(p2>>14)&0x3FF;
                temp--;
                p2&=~(0x3FF<<14);
                p2|=(temp<<14);
                ramw[(origaddr+4)>>1]=p2>>16;
                ramw[((origaddr+4)>>1)+1]=p2;
                tempaddr>>=3;
//                tempaddr+=((p4>>18)&0x3FF);
                p1&=0x7FF;
                p1|=(tempaddr<<11);
                ramw[origaddr>>1]=p1>>16;
                ramw[(origaddr>>1)+1]=p1;
                break;
//                exit(-1);

                case 1: /*Scaled Bitmap (not actually scaled though...*/
                p3=ramw[(objaddr>>1)+1]; p3|=ramw[objaddr>>1]<<16; objaddr+=4;
                p4=ramw[(objaddr>>1)+1]; p4|=ramw[objaddr>>1]<<16; objaddr+=4;
                objaddr+=4;
                p6=ramw[(objaddr>>1)+1]; p4|=ramw[objaddr>>1]<<16; objaddr+=4;
                tempaddr=((p2&0xFF000000)>>24)|(p1<<8);
                objaddr=(tempaddr<<3)&0x1FFFFF;
                temp2=(p4>>28)|((p3&0x3F)<<4);
                tempaddr=(p1>>11)<<3;
                temp=(p2>>3)&0x7FF;
                if ((temp|1)!=line) break;
                if (!((p2>>14)&0x3FF)) break;
                xscale=p6&255;
                if (p3&0x8000)
                {
                        xx=0;
                        for (x=0;x<temp2<<3;x+=2)
                        {
                                tempw=ramw[(tempaddr&0x1FFFFF)>>1];
                                tempaddr+=2;
                                oldxx=xx;
                                while ((xx>>5)==(oldxx>>5))
                                {
                                        if (tempw>>8) pixel(temp>>1,(xx>>5)+(p4&0xFFF),clut[tempw>>8]);
                                        xx+=xscale;
                                }
                                oldxx=xx;
                                while ((xx>>5)==(oldxx>>5))
                                {
                                        if (tempw&0xFF) pixel(temp>>1,(xx>>5)+(p4&0xFFF),clut[tempw&0xFF]);
                                        xx+=xscale;
                                }
                        }
                }
                else
                {
                        xx=0;
                        for (x=0;x<temp2<<3;x+=2)
                        {
                                tempw=ramw[(tempaddr&0x1FFFFF)>>1];
                                tempaddr+=2;
                                oldxx=xx;
                                while ((xx>>5)==(oldxx>>5))
                                {
                                        pixel(temp>>1,(xx>>5)+(p4&0xFFF),clut[tempw>>8]);
                                        xx+=xscale;
                                }
                                oldxx=xx;
                                while ((xx>>5)==(oldxx>>5))
                                {
                                        pixel(temp>>1,(xx>>5)+(p4&0xFFF),clut[tempw&0xFF]);
                                        xx+=xscale;
                                }
                        }
                }
                temp+=2;
                p2&=~0x3FF8;
                p2|=((temp&0x7FF)<<3);
                temp=(p2>>14)&0x3FF;
                temp--;
                p2&=~(0x3FF<<14);
                p2|=(temp<<14);
                ramw[(origaddr+4)>>1]=p2>>16;
                ramw[((origaddr+4)>>1)+1]=p2;
                tempaddr>>=3;
                p1&=0x7FF;
                p1|=(tempaddr<<11);
                ramw[origaddr>>1]=p1>>16;
                ramw[(origaddr>>1)+1]=p1;
                break;

                case 3: /*Branch*/
                tempaddr=((p2&0xFF000000)>>21)|(p1<<11);
//                printf("line %i %i cc %i %06X\n",line,(p2>>3)&0x7FF,(p2>>15)&3,tempaddr);
                switch ((p2>>15)&3)
                {
                        case 0:
                        if (((p2>>3)&0x7FE)==line)
                           objaddr=tempaddr;
                        break;
                        case 1:
                        if (((p2>>3)&0x7FE)<line)
                           objaddr=tempaddr;
                        break;
                        default:
                        printf("Bad CC %i\n",(p2>>15)&3);
                        exit(-1);
                }
                break;

                case 4: /*Stop*/
                objaddr=old;
                return;

                default:
                save_pcx("temp.pcx",buffer,desktop_palette);
                printf("Bad p2 %i %08X %08X\n",p2&7,p1,p2);
                exit(-1);
        }
        ins++;
        if (ins!=128) goto top;
        objaddr=old;
        return;
        exit(-1);
//        printf("%08X\n",old);
}

void copybuffer()
{
        blit(buffer,screen,0,0,0,0,370,300);
}

void closevideo()
{
        save_pcx("scrshot.pcx",buffer,pal);
        allegro_exit();
}
